#!/usr/bin/env python3

import sys
from collections import deque

dh = [1, 0, -1, 0]
dw = [0, 1, 0, -1]
ds = "SENW"

fin = open("travel.in", "r")
fout = open("travel.out", "w")

w, h, n = map(int, fin.readline().split())
mp = [fin.readline() for i in range(h)]

vh, vw = None, None
for i in range(h):
    for j in range(w):
        if mp[i][j] == 'V':
            vh, vw = i, j

d = [[0x7f7f7f7f for j in range(w)] for i in range(h)]
r = [[None for j in range(w)] for i in range(h)]

q = deque()

r[vh][vw] = -1
d[vh][vw] = 0
q.append((vh, vw))
while q:
    uh, uw = q.popleft()
    for i in range(4):
        th = uh + dh[i]
        tw = uw + dw[i]
        if th < 0 or th >= h or tw < 0 or tw >= w:
            continue
        if d[th][tw] != 0x7f7f7f7f:
            continue
        r[th][tw] = i
        if mp[th][tw] == 'T':
            d[th][tw] = d[uh][uw]
            q.appendleft((th, tw))
        else:
            d[th][tw] = d[uh][uw] + 1
            q.append((th, tw))

b = [[0 for j in range(w)] for i in range(h)]
for i in range(h):
    for j in range(w):
        if mp[i][j] != 'T':
            continue
        b[i][j] += 1
        for t in range(4):
            th = i + dh[t]
            tw = j + dw[t]
            if th < 0 or th >= h or tw < 0 or tw >= w:
                continue
            if mp[th][tw] == 'T':
                b[i][j] += 1

ans = int(1e9)
for i in range(h):
    for j in range(w):
        if b[i][j] == 0:
            continue
        if b[i][j] == 1:
            ans = min(ans, abs(i - vh) + abs(j - vw) + 2 * (n - 1))
        else:
            ans = min(ans, d[i][j] + n)

for i in range(h):
    for j in range(w):
        if b[i][j] == 0:
            continue
        if b[i][j] == 1 and ans == abs(i - vh) + abs(j - vw) + 2 * (n - 1):
            r, f = "??"
            while vh < i:
                f, r = 'SN'
                print(f, file=fout, end='')
                vh += 1
            while vh > i:
                f, r = 'NS'
                print(f, file=fout, end='')
                vh -= 1
            while vw < j:
                f, r = 'EW'
                print(f, file=fout, end='')
                vw += 1
            while vw > j:
                f, r = 'WE'
                print(f, file=fout, end='')
                vw -= 1
            for t in range(n - 1):
                print(r, file=fout, end='')
                print(f, file=fout, end='')
            print("", file=fout)
            sys.exit(0)
        if b[i][j] > 1 and ans == d[i][j] + n:
            path = []
            th, tw = i, j
            while r[th][tw] != -1:
                rr = r[th][tw]
                path.append(rr)
                th -= dh[rr]
                tw -= dw[rr]
            path = reversed(path)
            for x in path:
                if n <= 0:
                    break
                print(ds[x], file=fout, end='')
                vh += dh[x]
                vw += dw[x]
                if mp[vh][vw] == 'T':
                    n -= 1
            while n > 0:
                for t in range(4):
                    th = vh + dh[t]
                    tw = vw + dw[t]
                    if th < 0 or th >= h or tw < 0 or tw >= w:
                        continue;
                    if mp[th][tw] == 'T':
                        print(ds[t], file=fout, end='')
                        vh, vw = th, tw
                        n -= 1
                        break
            print("", file=fout);
            sys.exit(0)

